/*
* JBoss, Home of Professional Open Source
* Copyright 2006, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.metadata.spi.signature.javassist;

import javassist.CtConstructor;
import javassist.NotFoundException;
import org.jboss.metadata.spi.signature.ConstructorParametersSignature;

/**
 * Javassist Constructor parameters Signature.
 *
 * @author <a href="ales.justin@jboss.com">Ales Justin</a>
 */
public class JavassistConstructorParametersSignature extends ConstructorParametersSignature
{
   /**
    * Create a new Signature.
    *
    * @param constructor the method
    * @param param the parameter number
    * @throws javassist.NotFoundException for any error
    */
   public JavassistConstructorParametersSignature(CtConstructor constructor, int param) throws NotFoundException
   {
      super(param, JavassistSignatureFactory.convertParameters(constructor.getParameterTypes()));
   }
}